KEKIdentifier (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1.cms

## Class KEKIdentifier

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.cms.KEKIdentifier

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class KEKIdentifier
      extends ASN1Object

  RFC 5652: Content encryption key delivery mechanisms.

       KEKIdentifier ::= SEQUENCE {
           keyIdentifier OCTET STRING,
           date GeneralizedTime OPTIONAL,
           other OtherKeyAttribute OPTIONAL
       }

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `KEKIdentifier(byte[] keyIdentifier, ASN1GeneralizedTime date, OtherKeyAttribute other)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ASN1GeneralizedTime` | `getDate()`
    `static KEKIdentifier` | `getInstance(ASN1TaggedObject obj, boolean explicit)` Return a KEKIdentifier object from a tagged object.
    `static KEKIdentifier` | `getInstance(java.lang.Object obj)` Return a KEKIdentifier object from the given object.
    `ASN1OctetString` | `getKeyIdentifier()`
    `OtherKeyAttribute` | `getOther()`
    `ASN1Primitive` | `toASN1Primitive()` Produce an object suitable for an ASN1OutputStream.

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `encodeTo, encodeTo, equals, getEncoded, getEncoded, hasEncodedTagValue, hashCode`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### KEKIdentifier

          public KEKIdentifier(byte[] keyIdentifier,
                               ASN1GeneralizedTime date,
                               OtherKeyAttribute other)

  - ### Method Detail

    - #### getInstance

          public static KEKIdentifier getInstance(ASN1TaggedObject obj,
                                                  boolean explicit)

      Return a KEKIdentifier object from a tagged object.
      Parameters:
        `obj` - the tagged object holding the object we want.
        `explicit` - true if the object is meant to be explicitly tagged false otherwise.
      Throws:
        `java.lang.IllegalArgumentException` - if the object held by the tagged object cannot be converted.

    - #### getInstance

          public static KEKIdentifier getInstance(java.lang.Object obj)

      Return a KEKIdentifier object from the given object.

      Accepted inputs:

      - null → null
      - `KEKIdentifier` object
      - `ASN1Sequence` input formats with KEKIdentifier structure inside
      Parameters:
        `obj` - the object we want converted.
      Throws:
        `java.lang.IllegalArgumentException` - if the object cannot be converted.

    - #### getKeyIdentifier

          public ASN1OctetString getKeyIdentifier()

    - #### getDate

          public ASN1GeneralizedTime getDate()

    - #### getOther

          public OtherKeyAttribute getOther()

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

      Produce an object suitable for an ASN1OutputStream.
      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Specified by:
        `toASN1Primitive` in class `ASN1Object`
      Returns:
        a primitive representation of this object.